//---------------------------------------------------------------------------
#ifndef MainCodeH
#define MainCodeH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Chart.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>
#include <Series.hpp>
#include <Menus.hpp>
#include <stdlib.h>
#include  <strstrea.h>
#include "MatrixCode.h"

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TChart *Chart;
        TStaticText *StaticText2;
        TStringGrid *StringGrid2;
        TButton *Button1;
        TLineSeries *Series1;
        TPopupMenu *PopupMenu;
        TMenuItem *N1;
        TLineSeries *Series2;
        TLineSeries *Series3;
        TLineSeries *Series4;
        TStaticText *StaticText1;
        TStaticText *StaticText3;
        TStaticText *StaticText4;
        TMemo *Memo1;
        TEdit *Edit1;
        TEdit *Edit2;
        TLabel *Label1;
        TComboBox *ComboBox1;
        TStaticText *StaticText5;
        TEdit *Edit3;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall StringGrid1KeyPress(TObject *Sender, char &Key);
        void __fastcall StringGrid2KeyPress(TObject *Sender, char &Key);
        void __fastcall ChartContextPopup(TObject *Sender,
          TPoint &MousePos, bool &Handled);
        void __fastcall N1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
