//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "MainCode.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TMainForm *MainForm;    //   
TDifInert *DifInert[2]; // 
TDifInt   *DifInt;      // 

//---------------------------------------------------------------------------
//  TMainForm
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
        //  
        StringGrid2->Cells[0][0]="";
        StringGrid2->Cells[1][0]="";
        StringGrid2->Cells[0][1]="";
        StringGrid2->Cells[0][2]="";
        StringGrid2->Cells[0][3]="X";
}

//---------------------------------------------------------------------------
//   " "
void __fastcall TMainForm::Button1Click(TObject *Sender)
{
        float t;      // 
        float dt;     // 
        float rt;     // 
        float qt;     //  
        float xout;   //  
        float xin;    //  
        float er;     //    
        float xst;    // ,  
                      //   ,  
        DWORD i,m;    //
        AnsiString str;
        //   (   )
        if (StringGrid2->Cells[1][1]=="") StringGrid2->Cells[1][1]="0,0005";
        if (StringGrid2->Cells[1][2]=="") StringGrid2->Cells[1][2]="10";
        if (StringGrid2->Cells[1][3]=="") StringGrid2->Cells[1][3]="0,5";
        dt=StrToFloat(StringGrid2->Cells[1][1]);
        t=StrToFloat(StringGrid2->Cells[1][2]);
        xst=StrToFloat(StringGrid2->Cells[1][3]);
        // 
        DifInert[0]=new TDifInert(dt,1,1);
        DifInert[1]=new TDifInert(dt,1,1);
        DifInt=new TDifInt(dt,1);
        //  
        rt=0;xin=1;xout=0;
        // 
        for(i=0;i<4;i++) Chart->Series[i]->Clear();
        //    1000   
        m=t/(dt*1000);
        if (m==0) m=1;
        // 
        while (rt<t){
         //    - 
         er=xin-xout;
         //  -     1 
         DifInt->xin=er;
         //c  1- 
         DifInt->Euler();
         //  1    2-    3-
         DifInert[0]->xin=DifInt->dX[0]*2+DifInt->X[0];
         //c 3- 
         DifInert[0]->Euler();
         // 3-  4- 
         DifInert[1]->xin=DifInert[0]->X[0];
         //c 4- 
         DifInert[1]->Euler();
         //4-   
         xout=DifInert[1]->X[0];
         //   
         if ((xout<xst*0.95)|(xout>xst*1.05)) qt=rt;
         //  
         i++; if (!(i%m)) Chart->Series[0]->AddXY(rt,xout,"",clGreen);
         //     
         rt=rt+dt;
        }
        //    ymax,ymin   - 
        Chart->Series[1]->AddXY(0,xout*1.05,"",clRed);
        Chart->Series[1]->AddXY(t,xout*1.05,"",clRed);
        Chart->Series[2]->AddXY(0,xout*0.95,"",clRed);
        Chart->Series[2]->AddXY(t,xout*0.95,"",clRed);
        Chart->Series[3]->AddXY(qt,0,"",clBlue);
        Chart->Series[3]->AddXY(qt,xout*1.05,"",clBlue);
        //     
        if (abs(t-qt)<=dt*10) str=" / -   ";
        else  str=" /="+FloatToStrF(qt,ffFixed,5,4)+" ";
        Chart->Title->Text->Strings[1]=str;
        // 
        delete DifInt;
        delete DifInert[0];
        delete DifInert[1];
}
//---------------------------------------------------------------------------

// 
void __fastcall TMainForm::StringGrid1KeyPress(TObject *Sender, char &Key)
{
        if (Key=='.') Key=',';
        if (((Key<'0')|(Key>'9'))&(Key!=',')&(Key!=8)) Key=0;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StringGrid2KeyPress(TObject *Sender, char &Key)
{
        if (Key=='.') Key=',';
        if (((Key<'0')|(Key>'9'))&(Key!=',')&(Key!=8)) Key=0;
}
//---------------------------------------------------------------------------

//     
void __fastcall TMainForm::ChartContextPopup(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{
        PopupMenu->Popup(MousePos.x+MainForm->Left,MousePos.y+MainForm->Top);
}
//---------------------------------------------------------------------------

//       
void __fastcall TMainForm::N1Click(TObject *Sender)
{
        Chart->CopyToClipboardBitmap();
}
//---------------------------------------------------------------------------

