//---------------------------------------------------------------------------
#pragma hdrstop
#include "difmetod.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

//  TDifMetod     

//  TDifInt   ,
//      X,dX
TDifMetod::TDifMetod(int rank,float deltat){
        int i;
        N=rank;dt=deltat;
        X=new float[N];dX=new float[N];X1=new float[N];dX1=new float[N];
        k1=new float[N];k2=new float[N];k3=new float[N];k4=new float[N];
        for (i=0;i<N;i++){
         X[i]=0;dX[i]=0;}
}

// 
TDifMetod::~TDifMetod(){
        delete X;delete dX;delete X1;delete dX1;
        delete k1;delete k2;delete k3;delete k4;
}

//     - -, .. 
//  
void TDifMetod::Derive(float *X2, float *dX2){
}

// 
void TDifMetod::Euler(){
        int i;
        for(i=0;i<N;i++)
        X[i]=X[i]+dX[i]*dt;
        Derive(X,dX);           //    
                                //
}

//  
void TDifMetod::EulerModif(){
        int i;
        for(i=0;i<N;i++) X1[i]=X[i]+dX[i]*dt;
        Derive(X1,dX1);
        for(i=0;i<N;i++) X[i]=X[i]+1.0/2*(dX[i]+dX1[i])*dt;
        Derive(X,dX);           //    
                                //
}

//  
void TDifMetod::EulerAdvan(){
        int i;
        float X1[10],dX1[10];
        for(i=0;i<N;i++) X1[i]=X[i]+dX[i]*dt/2;
        Derive(X1,dX1);
        for(i=0;i<N;i++) X[i]=X[i]+dX1[i]*dt;
        Derive(X,dX);           //    
                                //
}

// - 4- 
void TDifMetod::RungeKutta4(){
        int i;
        Derive(X,k1);  for(i=0;i<N;i++) k1[i]=k1[i]*dt; // k1
        for(i=0;i<N;i++) X1[i]=X[i]+k1[i]/2;  //   k2
        Derive(X1,k2); for(i=0;i<N;i++) k2[i]=k2[i]*dt; // k2
        for(i=0;i<N;i++) X1[i]=X[i]+k2[i]/2;  //   k3
        Derive(X1,k3); for(i=0;i<N;i++) k3[i]=k3[i]*dt; // k3
        for(i=0;i<N;i++) X1[i]=X[i]+k3[i];    //   k4
        Derive(X1,k4); for(i=0;i<N;i++) k4[i]=k4[i]*dt; // k4
        // Xi+1
        for(i=0;i<N;i++) X[i]=X[i]+1.0/6*(k1[i]+2*k2[i]+2*k3[i]+k4[i]);
        Derive(X,dX);           //    
                                //
}
