//---------------------------------------------------------------------------
#pragma hdrstop
#include "difunit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

//       

//  TDifInt   
TDifInt::TDifInt(float deltat,float ku):
        //    -,
        //     -
        TDifMetod(1,deltat){
        k=ku;
}

//     - -, .. 
void TDifInt::Derive(float *X2, float *dX2){
        dX2[0]=k*xin;
}

//  TDifInert  
TDifInert::TDifInert(float deltat,float tau, float ku):
        //    -,
        //     -
        TDifMetod(1,deltat){
        t=tau;
        k=ku;
}

//     - -, .. 
void TDifInert::Derive(float *X2, float *dX2){
        dX2[0]=(k*xin-X2[0])/t;
}

//  TDifOsc  
TDifOsc::TDifOsc(float deltat,float tau, float xi):
        //    -,
        //     -
        TDifMetod(2,deltat){
        a0=tau*tau;
        a1=2*xi*tau;
}

//     - -, .. 
void TDifOsc::Derive(float *X2, float *dX2){
        dX2[0]=X2[1];
        dX2[1]=(-a1*X2[1]-X2[0]+xin)/a0;
}


